/**************************************************************************
*                                                                         *
*                   Acoustic Research Tool (ART)                          *
*                                                                         *
*   A Simulation Framework with Modelling Library for Acoustic Systems    *
*                                                                         *
*         Project of the Workgroup 2 of the Technical Committee           *
*      Musical Acoustics of the European Acoustics Association EAA)       *
*                                                                         *
*   http://www.eaa-fenestra.org/technical-committees/ma/workgroups/wg2    *
*                                                                         *
*  Copyright (C) 2013 by the authors and their organisations:             *
*    Alistair Braden            1)                                        *
*    Wilfried Kausel            2)         kausel(at)mdw.ac.at            *
*    Delphine Cadefaux          2)                                        *
*    Vasileios Chatziioannou    2)                                        *
*    Sadjad Siddiq              2)                                        *
*    Clemens Geyer              2)                                        *
*                                                                         *
*    1) School of Physics and Astronomy, Univ. of Edinburgh, GB           *
*       (http://www.ph.ed.ac.uk/)                                         *
*    2) Inst. of Music Acoustics, Univ. of Music, Vienna, AT              *
*       (http://iwk.mdw.ac.at)                                            *
*                                                                         *
*  This program is free software: you can redistribute it and/or modify   *
*  it under the terms of the GNU General Public License as published by   *
*  the Free Software Foundation, either version 3 of the License, or      *
*  any later version.                                                     *
*                                                                         *
*  This program is distributed in the hope that it will be useful,        *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
*  GNU General Public License for more details.                           *
*                                                                         *
*  You should have received a copy of the GNU General Public License      *
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.  *
*                                                                         *
***************************************************************************/

#ifndef SIMPLEMATRIX_H
#define SIMPLEMATRIX_H

#include <complex>
using namespace std;
typedef std::complex<double> dcomp;

class SimpleMatrix {
private:
	dcomp array[2][2];

public:
	SimpleMatrix();
	SimpleMatrix (const dcomp a, const dcomp b, const dcomp c, const dcomp d);
//	~SimpleMatrix();
	dcomp getArray(const int a, const int b) const {if ((a==0 || a==1) && (b==0 || b==1)) return array[a][b]; else return dcomp(-1,-1);}
	SimpleMatrix operator * (const SimpleMatrix& a);
	SimpleMatrix& operator = (const SimpleMatrix &a);
	void printAbs() const;
	void printMaple() const;
	void setValues(const dcomp a, const dcomp b, const dcomp c, const dcomp d);

};

#endif
